import pyjd 

from pyjamas.ui.Button import Button
from pyjamas.ui.RootPanel import RootPanel
from pyjamas.ui.Frame import Frame
from pyjamas import Window

from popups import MyDialog

def greet(sender):
    Window.alert("Hello, AJAX!")

from pyjamas.ui.Button import Button
from pyjamas.ui.CheckBox import CheckBox
from pyjamas.ui.VerticalPanel import VerticalPanel
from pyjamas.ui.HorizontalPanel import HorizontalPanel
from pyjamas.ui.HTML import HTML
from pyjamas.ui.DockPanel import DockPanel
from pyjamas.ui import HasAlignment
from pyjamas.ui.FlowPanel import FlowPanel
from pyjamas.ui.HTMLPanel import HTMLPanel
from pyjamas.ui.MenuBar import MenuBar
from pyjamas.ui.MenuItem import MenuItem
from pyjamas.ui.ScrollPanel import ScrollPanel
from pyjamas.ui.Composite import Composite
from pyjamas.ui.DialogBox import DialogBox
#from Logger import Logger
from pyjamas import DOM

def makeLabel(caption):
    html = HTML(caption)
    html.setStyleName("ks-layouts-Label")
    return html

news = """
    <b>SPECIFIC MESSAGE TO GOOGLE PLUS ACCOUNT NAME REVIEWERS:</b><br />
    don't make me get my name changed by title deed to "L Kcl".
    it looks weird.  and sounds like i'm an alien character in a reaaally bad
    sci-fi book.
    <br />
    Latest projects:<br />
    <ul>
        <li /><p><a href="http://lkcl.net/ev">200mpg+ Hybrid EV</a> Project:
              to create an affordable 1,000 mile range 3 seat Hybrid Electric
              Vehicle from mass-produced off-the-shelf parts. </p>
        <li /><a href="http://elinux.org/Embedded_Open_Modular_Architecture">EOMA Initiative</a>:
              Design of affordable mass-produced Laptops, Tablets and other
              Computing Appliances, to help simplify and accelerate supply
              of products.  For details, contact
              <a href="http://www.rh-technology.com">RH Technology Ltd</a>.
    </ul>
"""

def _show_dialog(dlg, left, top, dlgwidth):

    width = Window.getClientWidth()
    height = Window.getClientHeight()

    if left + dlgwidth > width - 10:
        left = (width / 2) - (width - dlgwidth) / 2
    if left + dlgwidth > width - 10:
        left = 10
        dlgwidth = width - 20

    dlgheight = 500
    if top + dlgheight > height - 10:
        top = (height / 2) - (height - dlgheight) / 2
    if top + dlgheight > height - 10:
        top = 10
        dlgheight = height - 20

    dlg.set_width(dlgwidth)
    dlg.set_height(dlgheight)
    dlg.setPopupPosition(left, top)
    dlg.show()

class Box(Composite):

    def __init__(self, txt, heading, style, boxwidth):

        Composite.__init__(self)

        self.p = VerticalPanel()
        self.p.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        self.p.setVerticalAlignment(HasAlignment.ALIGN_TOP)

        self.p.add(makeLabel(heading))
        self.p.add(HTML(txt, True))
        self.p.setStyleName(style)
        self.p.setWidth(boxwidth)

        self.setWidget(self.p)

        self.dlg = None

    def add_button(self, text, parent):

        self.popup_button = Button(text, parent)
        self.p.add(self.popup_button)
        self.p.setCellHorizontalAlignment(self.popup_button, HasAlignment.ALIGN_RIGHT)
        self.p.setCellVerticalAlignment(self.popup_button, HasAlignment.ALIGN_BOTTOM)

    def show_dialog(self, dlgwidth):

        left = self.getAbsoluteLeft() + 10
        top = self.getAbsoluteTop() + 10
        _show_dialog(self.dlg, left, top, dlgwidth)

    def onShow(self):
        pass

class NewsDialog(DialogBox):
    def __init__(self):
        DialogBox.__init__(self, glass=True)
        self.setText("Latest News")

        #iframe = Frame("http://lkcl.net/ev")
        #sp = ScrollPanel(iframe)
        closeButton = Button("Close", self)
        #msg = HTML(news, True)

        dock = DockPanel()
        dock.setSpacing(4)

        dock.add(closeButton, DockPanel.SOUTH)
        #dock.add(msg, DockPanel.NORTH)
        #dock.add(sp, DockPanel.CENTER)

        dock.setCellHorizontalAlignment(closeButton, HasAlignment.ALIGN_RIGHT)
        #dock.setCellWidth(iframe, "100%")
        dock.setWidth("100%")
        #sp.setWidth("80%")
        #sp.setHeight("80%")
        self.setWidget(dock)

    def onClick(self, sender):
        self.hide()

class Creativity(Box):

    def __init__(self, boxwidth):

        txt = "<ul class='nodec'>"
        txt += "<li /> <a href='http://allpoetry.com/poets/lkcl'>Allpoetry</a>"
        txt += "<li /><a href='./poems/'>Poems</a>"
        txt += "<li /> <a href='http://freemind.sf.net'>FreeMind</a> and "
        txt += "       <a href='http://leo.sf.net'>Leo</a>"
        txt += "<li /><a href='/ev/'>200mpg+ Hybrid EV Design</a>"

        txt += "</ul>"

        Box.__init__(self, txt, 'Creativity', 'ks-creativitybox', boxwidth)

        self.dlg = MyDialog('Creativity', './creativity.html')

    def onShow(self):
        pass

class Technology(Box):

    def __init__(self, boxwidth):

        txt = "<ul class='nodec'>"
        #txt += "<li /> Network protocols"
        txt += "<li /> Secure E-Commerce"
        txt += "<li /> Secure Web hosting"
        txt += "<li /> Reverse-engineering"
        txt += "<li /> <a href='./amcaius'>Property Key Management</a>"
        txt += "<li /> <a href='http://rhombus-tech.net'>Hardware Design</a>"
        txt += "</ul>"

        Box.__init__(self, txt, 'Technology', 'ks-technologybox', boxwidth)

        self.dlg = MyDialog('Technology', './technology.html')

    def onShow(self):
        pass

class Contact(Box):

    def __init__(self, boxwidth):

        txt = "<ul class='nodec'>"
        txt += "<li /><a href='mailto:lkcl@lkcl.net'>lkcl@lkcl.net</a>"
        txt += "<li /><a href='mailto:lkcl@rhombus-tech.net'>lkcl@rhombus-tech.net</a>"
        txt += "<li /><a href='skype:lkcl..'>Skype 'lkcl..'</a>"
        txt += "</ul>"

        Box.__init__(self, txt, 'Contact', 'ks-contactbox', boxwidth)

        self.dlg = MyDialog('Email', './output_email/email.html')

    def onShow(self):
        pass

class More(Box):

    def __init__(self, boxwidth):

        txt = "<ul class='nodec'>"
        txt += "<li /><a href='http://advogato.org/person/lkcl/'>Advogato.org</a>"
        txt += "<li /><a href='http://www.cb1.com/~lkcl/'>CB1 Home page</a>"
        txt += "<li /><a href='http://www.google.com/search?q=Luke+Kenneth+Casson+Leighton&ie=ISO-8859&hl=en&btnG=Google+Search'>Google Search</a>"
        txt += "<li /><a href='https://www.facebook.com/luke.k.leighton'>Facebook page...</a>"
        txt += "</ul>"

        Box.__init__(self, txt, 'More...', 'ks-morebox', boxwidth)

    def onShow(self):
        pass

class Links(Box):

    def __init__(self, boxwidth):

        txt = "<ul class='nodec'>"
        txt += "<li /><a href='http://www.linkedin.com/in/lkclnet'>LinkedIn Profile</a>"
        txt += "<li /><a href='./cv.txt'>CV</a>"
        txt += "<li /><a href='./crypto/'>Cryptography</a>"
        txt += "<li /><a href='./reports/index.html'>Reports</a>"
        txt += "</ul>"

        Box.__init__(self, txt, 'Links', 'ks-linksbox', boxwidth)

    def onShow(self):
        pass

class Spirituality(Box):

    def __init__(self, boxwidth):

        txt = "<ul class='nodec'>"
        txt += "<li /><a href='http://heartofhealing.co'>Heart of Healing</a>"
        txt += "<li /><a href='http://www.iawwai.com'>IawWai</a>"
        txt += "<li /><a href='./articles/goethe_theory_of_knowledge'>Practical Theory of Knowledge</a>"

        txt += "</ul>"

        Box.__init__(self, txt, 'Spirituality', 'ks-spiritualitybox', boxwidth)

    def onShow(self):
        pass

class FreeSoftware(Box):

    def __init__(self, boxwidth):

        txt = "<ul class='nodec'>"
        txt += "<li /><a href='http://pyjs.org'>Pyjamas Project</a>"
        txt += "<li /><a href='http://sf.net/users/lkcl'>Sourceforge Profile</a>"
        txt += "<li /><a href='http://gitorious.org/~lkcl'>Gitorious Profile</a>"
        txt += "<li /><a href='http://www.gnu.org/software/pythonwebkit'>PythonWebkit</a>"
        txt += "</ul>"

        Box.__init__(self, txt, 'Free Software', 'ks-funbox', boxwidth)

    def onShow(self):
        pass


    
class Layouts(Composite):

    def __init__(self):

        Composite.__init__(self)

        panel = VerticalPanel()
        panel.setSpacing(8)
        panel.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)
        panel.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        
        self.panel = panel

        self.setWidget(panel)
        self.setStyleName("ks-layouts")

        #self.news = NewsDialog()
        #self.news.show()

        Window.addWindowResizeListener(self)

        width = Window.getClientWidth()
        height = Window.getClientHeight()

        self.toprow = None
        self.onWindowResized(width, height)

    def create_layout(self):

        self.creativity = Creativity("240px")
        self.creativity.add_button('More', self)
        self.technology = Technology("240px")
        self.technology.add_button('More', self)

        self.contact = Contact("240px")
        self.contact.add_button('Email', self)
        self.more = More("240px")
        self.links = Links("240px")

        self.fun = FreeSoftware("240px")
        self.spirituality = Spirituality("240px")

        width = Window.getClientWidth()

        if width > 800:

            self.ads = Frame("./ads.html")
            self.ads.setStyleName("ad-frame")
            toprow = HorizontalPanel()
            middlerow = HorizontalPanel()
            bottomrow = HorizontalPanel()

        elif width > 640:

            self.ads = Frame("./ads_shorter.html")
            self.ads.setStyleName("ad-frame-shorter")
            toprow = HorizontalPanel()
            middlerow = VerticalPanel()
            bottomrow = HorizontalPanel()

        else:

            self.ads = Frame("./ads_short.html")
            self.ads.setStyleName("ad-frame-short")
            toprow = VerticalPanel()
            middlerow = VerticalPanel()
            bottomrow = VerticalPanel()

        self.toprow = toprow
        self.middlerow = middlerow
        self.bottomrow = bottomrow

        toprow.setSpacing(8)
        toprow.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        toprow.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)

        middlerow.setSpacing(8)
        middlerow.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        middlerow.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)

        bottomrow.setSpacing(8)
        bottomrow.setVerticalAlignment(HasAlignment.ALIGN_MIDDLE)
        bottomrow.setHorizontalAlignment(HasAlignment.ALIGN_CENTER)

        toprow.add( self.technology) #, DockPanel.EAST)
        toprow.add( self.creativity) #, DockPanel.WEST)

        middlerow.add(self.more) #, DockPanel.WEST)
        middlerow.add(self.contact) #, DockPanel.CENTER)
        middlerow.add(self.links) #, DockPanel.EAST)

        bottomrow.add( self.spirituality) #, DockPanel.EAST)
        bottomrow.add( self.fun) #, DockPanel.WEST)

        txt = "a squeeze-me site, designed with "
        txt += "<a href='http://code.google.com/p/pyjamas'>pyjamas</a>."
        txt += " squish me with your browser"
        txt += " (even to as little as 300 pixels wide!)"
        txt += " and i should still look reasonable,"
        txt += " and not have a horizontal scroll-bar."
        txt += " here's the <a href='./site_code'>source code</a> for this site."
        self.html = HTML(txt, True)
        self.html.setStyleName("ks-footer")


        self.panel.add(self.ads)
        self.panel.add(toprow)
        self.panel.add(middlerow)
        self.panel.add(bottomrow)
        self.panel.add(self.html)
        
    def onWindowResized(self, width, height):

        dlgwidth = 400
        left = (width / 2) - (dlgwidth) / 2
        dlgheight = 280
        top = (height / 2) - (dlgheight) / 2

        if left + dlgwidth > width - 10:
            left = 10
            dlgwidth = width - 20

        #self.news.setWidth(dlgwidth)
        #self.news.setHeight(dlgheight)
        #self.news.setPopupPosition(left, top)

        if self.toprow is not None:
            self.toprow.removeFromParent()
            self.middlerow.removeFromParent()
            self.bottomrow.removeFromParent()
            self.html.removeFromParent()
            self.ads.removeFromParent()

        self.create_layout()

    def onShow(self):
        pass

    def onClick(self, sender):

        if sender == self.creativity.popup_button:
            self.creativity.show_dialog(600)
        elif sender == self.technology.popup_button:
            self.technology.show_dialog(400)
        elif sender == self.contact.popup_button:
            self.contact.show_dialog(600)


if __name__ == '__main__':
    pyjd.setup("./public/index.html")
    b = Layouts()
    RootPanel().add(b)
    pyjd.run()
